# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_updateservicesapprovalrule`](#dsc_updateservicesapprovalrule): The DSC UpdateServicesApprovalRule resource type. Automatically generated from version 1.0.73.0
* [`dsc_updateservicescleanup`](#dsc_updateservicescleanup): The DSC UpdateServicesCleanup resource type. Automatically generated from version 1.0.73.0
* [`dsc_updateservicesserver`](#dsc_updateservicesserver): The DSC UpdateServicesServer resource type. Automatically generated from version 1.0.73.0

## Resource types

### `dsc_updateservicesapprovalrule`

The DSC UpdateServicesApprovalRule resource type.
Automatically generated from version 1.0.73.0

#### Properties

The following properties are available in the `dsc_updateservicesapprovalrule` type.

##### `dsc_classifications`

Data type: `Optional[Array[String]]`

Classifications in the approval rule.

##### `dsc_computergroups`

Data type: `Optional[Array[String]]`

Computer groups the approval rule applies to.

##### `dsc_enabled`

Data type: `Optional[Boolean]`

Whether the approval rule is enabled.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

An enumerated value that describes if WSUS is configured. Present {default}   Absent    

##### `dsc_products`

Data type: `Optional[Array[String]]`

Products in the approval rule.

##### `dsc_runrulenow`

Data type: `Optional[Boolean]`

Run the approval rule after it has been created.

##### `dsc_synchronize`

Data type: `Optional[Boolean]`

Synchronize after creating or updating the approval rule.

#### Parameters

The following parameters are available in the `dsc_updateservicesapprovalrule` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the approval rule.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_updateservicescleanup`

The DSC UpdateServicesCleanup resource type.
Automatically generated from version 1.0.73.0

#### Properties

The following properties are available in the `dsc_updateservicescleanup` type.

##### `dsc_cleanuplocalpublishedcontentfiles`

Data type: `Optional[Boolean]`

Cleanup local published content files.

##### `dsc_cleanupobsoletecomputers`

Data type: `Optional[Boolean]`

Delete computers that have not contacted the server in 30 days or more.

##### `dsc_cleanupobsoleteupdates`

Data type: `Optional[Boolean]`

Delete updates that are expired and have not been approved for 30 days or more, and delete older update revisions that have not been approved for 30 days or more.

##### `dsc_cleanupunneededcontentfiles`

Data type: `Optional[Boolean]`

Delete update files that aren't needed by updates or downstream servers.

##### `dsc_compressupdates`

Data type: `Optional[Boolean]`

Compress updates.

##### `dsc_declineexpiredupdates`

Data type: `Optional[Boolean]`

Decline updates that aren't approved and have been expired by Microsoft.

##### `dsc_declinesupersededupdates`

Data type: `Optional[Boolean]`

Decline updates that have not been approved fo 30 days or more, are not currently needed by any clients, and are superseded by an approved update.

##### `dsc_timeofday`

Data type: `Optional[String]`

Time of day to start cleanup.

#### Parameters

The following parameters are available in the `dsc_updateservicescleanup` type.

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

An enumerated value that describes if the WSUS cleanup task exists. Present {default}   Absent    

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_updateservicesserver`

The DSC UpdateServicesServer resource type.
Automatically generated from version 1.0.73.0

#### Properties

The following properties are available in the `dsc_updateservicesserver` type.

##### `dsc_classifications`

Data type: `Optional[Array[String]]`

Update classifications, * for all.

##### `dsc_contentdir`

Data type: `Optional[String]`

Folder for WSUS update files.

##### `dsc_languages`

Data type: `Optional[Array[String]]`

Update languages, * for all.

##### `dsc_products`

Data type: `Optional[Array[String]]`

Update products, * for all.

##### `dsc_proxyserverbasicauthentication`

Data type: `Optional[Boolean]`

Allow proxy server basic authentication.

##### `dsc_proxyservercredentialusername`

Data type: `Optional[String]`

Proxy server credential username.

##### `dsc_proxyservername`

Data type: `Optional[String]`

Proxy server to use when synchronizing, omit for no proxy.

##### `dsc_proxyserverport`

Data type: `Optional[Integer[0, 65535]]`

Proxy server port.

##### `dsc_sqlserver`

Data type: `Optional[String]`

SQL Server for the WSUS database, omit for Windows Internal Database.

##### `dsc_synchronizationsperday`

Data type: `Optional[Integer[0, 65535]]`

Synchronizations per day.

##### `dsc_synchronize`

Data type: `Optional[Boolean]`

Begin initial synchronization.

##### `dsc_synchronizeautomatically`

Data type: `Optional[Boolean]`

Synchronize automatically.

##### `dsc_synchronizeautomaticallytimeofday`

Data type: `Optional[String]`

First synchronization.

##### `dsc_updateimprovementprogram`

Data type: `Optional[Boolean]`

Join the Microsoft Update Improvement Program.

##### `dsc_upstreamservername`

Data type: `Optional[String]`

Upstream WSUS server, omit for Microsoft Update.

##### `dsc_upstreamserverport`

Data type: `Optional[Integer[0, 65535]]`

Port of upstream WSUS server.

##### `dsc_upstreamserverreplica`

Data type: `Optional[Boolean]`

Replica of upstream WSUS server.

##### `dsc_upstreamserverssl`

Data type: `Optional[Boolean]`

Use SSL with upstream WSUS server.

#### Parameters

The following parameters are available in the `dsc_updateservicesserver` type.

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

An enumerated value that describes if WSUS is configured. Present {default}   Absent    

##### `dsc_proxyservercredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Proxy server credential, omit for anonymous.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the initial configuration.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

